<?php
namespace Teknisa\PLA\Modules\Mymeals\Controllers;

use Zeedhi\Framework\DTO;

class Pla02010AlteracaoComensaisController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $crudService;
    protected $Pla02010AlteracaoComensaisService;
    
    public function __construct($crudService, $parameterBag, $Pla02010AlteracaoComensaisService) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->Pla02010AlteracaoComensaisService = $Pla02010AlteracaoComensaisService;
    }

    public function atualizaCardadia(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        
        try{
            $this->Pla02010AlteracaoComensaisService->iniciaTransacao();
            
            $this->Pla02010AlteracaoComensaisService->atualizaCardadia($row);
            
            $this->Pla02010AlteracaoComensaisService->flush();
            $this->Pla02010AlteracaoComensaisService->commit();
        }catch(\Exception $e){
            $this->Pla02010AlteracaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function atualizaCompcard(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        
        try{
            $this->Pla02010AlteracaoComensaisService->iniciaTransacao();
            
            $this->Pla02010AlteracaoComensaisService->atualizaCompcard($row);
            
            $this->Pla02010AlteracaoComensaisService->flush();
            $this->Pla02010AlteracaoComensaisService->commit();
        }catch(\Exception $e){
            $this->Pla02010AlteracaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function atualizaCardacli(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        
        try{
            $this->Pla02010AlteracaoComensaisService->iniciaTransacao();
            
            $this->Pla02010AlteracaoComensaisService->atualizaCardacli($row);
            
            $this->Pla02010AlteracaoComensaisService->flush();
            $this->Pla02010AlteracaoComensaisService->commit();
        }catch(\Exception $e){
            $this->Pla02010AlteracaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function verificaParamPlaneja(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = "pla02010_paramplaneja";
        $this->parameterBagColumns = array('CDFILIAL','IDSOMACOMEST');
        $this->find($request, $response);
    }

    public function insereConfirmarefe(DTO\Request $request, DTO\Response $response){
        $rows = $request->getDataSet()->getRows();
        try{
            $this->Pla02010AlteracaoComensaisService->iniciaTransacao();
            
            foreach ($rows as $row) {
                $this->Pla02010AlteracaoComensaisService->insereConfirmarefe($row);
                $this->Pla02010AlteracaoComensaisService->flush();
            }
            $this->Pla02010AlteracaoComensaisService->commit();
            
        }catch(\Exception $e){
            $this->Pla02010AlteracaoComensaisService->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }
    
    public function retornaInfo(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02010_informacoes_prato";
        $this->parameterBagColumns = array('NRORG', 'CDFILIAL','CDSERVFILI','DTCARDAPIO');

        $this->find($request, $response);
    }
    
    public function retornaCardapio(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02010_cardapio";
        $this->parameterBagColumns = array('NRORG', 'CDFILIAL','NRCARDAPIO');

        $this->find($request, $response);
    }
    
    public function retornaTurno(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02010_turno";
        $this->parameterBagColumns = array('CDSERVFILI','CDFILIAL','NRCARDAPIO');

        $this->find($request, $response);
    }
    
    public function retornaPontoEntrega(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = "pla02010_ponto_entrega";
        $this->parameterBagColumns = array('CDFILIAL','NRCARDAPIO');

        $this->find($request, $response);
    }
    
   	public function find(DTO\Request\Filter $request, DTO\Response $response) {
		$this->executa('find', $request, $response);
	}

	public function save(DTO\Request $request, DTO\Response $response){
		$this->executa('save', $request, $response);
	}

	public function delete(DTO\Request $request, DTO\Response $response) {
		$this->executa('delete', $request, $response);
	}

	private function executa($funcao, $request, $response){
		try {
			parent::$funcao($request, $response);
		} catch (\Exception $e) {
			$exception = strstr($e->getMessage(), "oci_execute(): ORA-");
			$string = strstr($exception, "-");
			$codigo = substr($string, 1, 5);

			if (array_key_exists($codigo, $this->msgErro))
				$erro = $this->msgErro[$codigo];
			else
				$erro = $this->msgErro["default"];

			$response->setError(new Error($erro, 'E'));
		}
	}

}