<?php
namespace Teknisa\PLA\Modules\Prato\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Pla13200AgrupamentoDePratos extends \Teknisa\GER\Controllers\TeknisaCrud{
    
    protected $crudService;
    protected $parameterBag;
	protected $util;

	public function __construct($crudService, $parameterBag, $util) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->util = $util;
    }
    
    public function saveAgrupamento(DTO\Request $request, DTO\Response $response) {
        try {
            $this->dataSourceName = "agrupgrprat";
            $row = $request->getDataSet()->getRows()[0];

            if ($row["__is_new"]) {
                $this->util->validateDuplicatedRecords($row, $this->dataSourceName, array("CDAGRUPGRPRAT","IDTIPORESTRICAO"));
            }

            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
    
}
